/***********************************************************************
     Class name:       Master_thread
     Description:      An instantiable class to run the given command
                       that passed as a parameter. It handles the 
		       standard output stream and the standard error
		       stream by using different thread.
     Author:           Leung, Tak Wing
     Student ID:       9016254840
     Lecture:          CS 537
     Other classes:    StdOut and StdErr
***********************************************************************/

import java.io.*;

    public class Master_thread implements Runnable{
	public boolean background;
	public Process p;
	public String[] cmd;

	public Master_thread(String[] argv){
	    cmd=argv;
	}

	public void run(){

	    if(cmd==null){
		//if(background==true)
		//System.out.print(Shell.PROMPT);
		return;
	    }
	    //Rountine to detect the exit command
	    if(cmd[0].equals("exit")){
		Shell.exit=true;
		return;
	    }

	    //actually running the cmd
	    try{
		p=Runtime.getRuntime().exec(cmd);
	    }
	    catch(IOException e){
		System.out.println(cmd[0]+": Command not found.");
	    }

	    //process unable to create
	    if(p==null) return;

	    //Thread creating to handle the standard out and standard error
	    Thread stdout = new Thread(new StdOut(p));
	    Thread stderr = new Thread(new StdErr(p));
	    stdout.start();
	    stderr.start();
	    try{
		stdout.join();
		stderr.join();
	    }
	    catch(InterruptedException e){
		System.out.println("INTERRUPTED EXCEPTION DETECTED!");
	    }
	    if(background==true&&Shell.fileopt==false&&!cmd.equals(" ")){
		//System.out.print(Shell.PROMPT);
		//System.out.println("\n[3]\tDone\t\t\t"+cmd[0]+"\n");
		System.out.print(Shell.PROMPT);
	    }
	}

	//Class used to handle standard output
	public class StdOut implements Runnable{
	    Process p;
	
	    public StdOut(Process p1){
		p=p1;
	    }
	
	    public void run(){
		try{
		    BufferedReader br= new BufferedReader(new InputStreamReader(p.getInputStream()));
		    String s;
		    while((s=br.readLine())!=null){
			System.out.println(s);
		    }
		}
		catch(IOException e)
		    {
			System.out.println("IO ERROR IN STDOUT!");
		    }
	    }
	}
	
	
	//Class used to handle standard error
	public class StdErr implements Runnable{
	    Process p;
	    
	    public StdErr(Process p1){
		p=p1;
	    }
	    
	    public void run(){
		try{
		    BufferedReader br= new BufferedReader(new InputStreamReader(p.getErrorStream()));
		    String s;
		    while((s=br.readLine())!=null){
			System.out.println(s);
		    }
		}
		catch(IOException e)
		    {
			System.out.println("IO ERROR IN STDERR!");
		    }
	    }
	}
    }
