/** CS 537, Fall 2002, Project 2.
 * A supplier of energy resources.
 */
public class Supplier implements Runnable, Enron {
    /** Number of times to iterate before terminating. */
    private int iterations;

    /** Total produced thus far */
    private int[] produced  = new int[COMMODITIES];

    /** Create a new producer.
     * @param iteration the number of times to iterate before terminating.
     */
    public Supplier(int iterations) {
        this.iterations = iterations;
    } // Supplier(int)

    /** Indicate the amount of each resource produced.
     * @param amt a vector of amounts allocated by the caller and filled in
     * here with the total amounts produced thus far.
     */
    public synchronized void getProduction(int[] amt) {
        for (int i = 0; i < COMMODITIES; i++)
            amt[i] = produced[i];
    } // getProduction(int[])

    /** Main loop.
     * Repeatedly generate sell orders to random traders.  After
     * <i>iterations</i> iterations, sleep for three seconds and then
     * kill the entire program.
     */
    public void run() {
        for (int i = 0; i < iterations; i++) {
            try {
                Thread.sleep(Project2.randInt(100));
            } catch (Exception e) {
                e.printStackTrace();
            }
            int commodity = Project2.randInt(COMMODITIES);
            int amount = Project2.randInt(1,10);
            produced[commodity] += amount;
            Project2.debug(
                "supplying " + amount
                + " " + cunit[commodity] + (amount == 1 ? "" : "s")
                + " of " + cname[commodity]
                + " to " + cname[commodity] + " trader");
            Project2.specialist(commodity).supply(amount);

        }
        Project2.debug("Supplier sleeping ...");
        try {
            Thread.sleep(3000);
        }
        catch (InterruptedException e) { e.printStackTrace(); }

        Project2.terminateProgram();
    } // run()
} // Supplier
