/** CS 537, Fall 2002, Project 2.
 * Interface to be implmented by Traders.
 */
public interface Trader {
    /** Report on the total amount of resources held by this Trader.
     * @param result a vector of amounts, one for each commodity, allocated
     * by the caller and filled in by this Trader.
     */
    void getAmountOnHand(int[] result);

    /** A purchase request from a customer.
     * The caller is blocked until the request can be completely filled.
     * @param amount the amount needed of each commodity.
     */
    void buy(int[] order);

    /** Respond to a trade request from another trader.
     * Delay the caller until this Trader can complete the trade.
     * @param what the commodity the other trader wants to trade.
     * @param amount the number of units to trade.
     */
    void trade(int what, int amount);

    /** Accept more resources from the producer.
     * @param amount the number of units of this Trader's "special" commodity
     *               supplied.
     */
    void supply(int amount);
} // Trader
