// the DiskTester class

public class DiskTester {

    public static void main(String args[]) {
	if (args.length < 2) return;

	int count = Integer.parseInt(args[1]);

	if (args[0].equals("random")) {
	    random(count);
	}
    }
    public static void random(int count) { 
	int blockSize = Library.getDiskBlockSize();
	int numBlocks = Library.getDiskBlockCount();
	byte[] buffer = new byte[blockSize];	

	for (int i = 0; i < count; i++) {
	    int j = (int) (Math.random() * numBlocks); // block j
	    int k = (int) (Math.random() * 256);      // pattern k

	    // test for the read and write to disk
	    setPattern(k, buffer);
	    Library.writeDiskBlock(j, buffer);
	    clearPattern(buffer);
	    Library.readDiskBlock(j, buffer);
	    if (!checkPattern(k, buffer)) {
		Library.output("Test block "+j+", pattern "+k+" failed! \n");
	    } else {
		Library.output("Test block "+j+", pattern "+k+" passed! \n");
	    }
	}
    }
    
    private static void setPattern(int blockNumber, byte[] buffer){
	for (int i=0; i < buffer.length; i++){
	    buffer[i] = (byte) (blockNumber + i);
	}
    }

    private static boolean checkPattern(int blockNumber, byte[] buffer){
	for (int i = 0; i <buffer.length; i++){
	    if (buffer[i] != (byte) (blockNumber + i))
		return false;
	}
	return true;
    }

    private static void clearPattern(byte[] buffer) {
	for (int i=0; i <buffer.length; i++) {
	    buffer[i]=0;
	}
    }
}






