// Block access within a file
// takes an Inode and a block-offset of a block within the file 
// (lets say block A)
// return a pointer (short) to block A 
// (i.e. return the block number of block A in disk)
// return -1 if the block does not exist (disk full)

// (offset within the direct reference range)

public short getBlockNum(int operation, Inode inode, int offset){
    
    if (offset < 11) { // lvl 0

	// check if the block exists
	if (inode.direct[offset] != 0){
	    // block exists return
	    return inode.direct[offset];
	}
	else { 
	    if (operation == READ){ //return error for block does not exists
		return -1;
	    }
	    else { 
		if (operation == WRITE) {
		    // block does not exists, allocate it in the disk
		    // not return error untill cannot allocate new block 
		    // (i.e. disk full)
		
		    // allocate the new block
		    int newBlkNum = getNewBlock();
		    if (newBlkNum != -1){
			return (short) newBlkNum;
		    }
		    else{ // cannot allocate new free block (disk full), 
			// propagate the error
			return -1;
		    }
		}
	    }
	    else { //operation is not READ nor WRITE, error !
		System.out.println("getBlockNum: operation "+ operation+ "  is not READ nor WRITE")
		    return -1;
	    }
	}
    }
}






